sbcast(1)

NAME
sbcast - transmit a file to the nodes allocated to a SLURM job.

SYNOPSIS
sbcast [-CfFjpstvV] SOURCE DEST

DESCRIPTION
sbcast is used to transmit a file to all nodes allocated to the currently active SLURM job. This command should only be executed from within a SLURM batch job or within the shell spawned after a SLURM job's resource allocation. SOURCE is the name of a file on the current node. DEST should be the fully qualified pathname for the file copy to be created on each node. DEST should be on a file system local to that node. Note that parallel file systems may provide better performance than sbcast can provide, although performance will vary by file size, degree of parallelism, and network type.

OPTIONS

-C, --compress
    Compress the file being transmitted.

-f, --force
    If the destination file already exists, replace it.

-F number, --fanout=number
    Specify the fanout of messages used for file transfer. Maximum value is currently eight.

-j number, --jobid=number
    Specify the jobid to use. If ran inside an allocation this is unneeded as the jobid will read from the environment.

-p, --preserve
    Preserves modification times, access times, and modes from the original file.

-s size, --size=size
    Specify the block size used for file broadcast. The size can have a suffix of k or m for kilobytes or megabytes respectively (defaults to bytes). This size subject to rounding and range limits to maintain good performance. This value may need to be set on systems with very limited memory.

-t seconds, fB--timeout=seconds
    Specify the message timeout in seconds. The default value is MessageTimeout as reported by "scontrol show config". Setting a higher value may be necessitated by relatively slow I/O performance on the compute node disks.

-v, --verbose
    Provide detailed event logging through program execution.

-V, --version
    Print version information and exit.

ENVIRONMENT VARIABLES

Some sbcast options may be set via environment variables. These environment variables, along with their corresponding options, are listed below. (Note: Command line options will always override these settings.)

SBCAST_COMPRESS
    -C, --compress

SBCAST_FANOUT
    -F number, fB--fanout=number

SBCAST_FORCE
    -f, --force

SBCAST_PRESERVE
    -p, --preserve

SBCAST_SIZE
    -s size, --size=size

SBCAST_TIMEOUT
    -t seconds, fB--timeout=seconds

AUTHORIZATION
When using the SLURM db, users who have AdminLevel's defined (Operator or Admin) and users who are account coordinators are given the authority to invoke sbcast on other user's jobs.

EXAMPLE
Using a batch script, transmit local file my.prog to /tmp/my.proc on the local nodes and then execute it.
> cat my.job
#!/bin/bash
sbcast my.prog /tmp/my.prog
srun /tmp/my.prog
> sbatch --nodes=8 my.job
srun: jobid 12345 submitted

COPYING
Copyright (C) 2006-2010 The Regents of the University of California. Produced at Lawrence Livermore National Laboratory (cf, DISCLAIMER).
Copyright (C) 2010-2013 SchedMD LLC.

This file is part of SLURM, a resource management program. For details, see <http://slurm.schedmd.com/>.

SLURM is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

SLURM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

SEE ALSO
srun(1)